<?php
include("begin.php");
include("adminlib.php");
$textpart = "sources";
include("getlang.php");
include("$mylanguage/admintext.php");
include("$mylanguage/text.php");
tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;
include("checklogin.php");
include("prefixes.php");

if($session_charset != "UTF-8") {
	$criteria = tng_utf8_decode($criteria);
	$myffirstname = tng_utf8_decode($myffirstname);
	$myflastname = tng_utf8_decode($myflastname);
	$myhusbname = tng_utf8_decode($myhusbname);
	$mywifename = tng_utf8_decode($mywifename);
}

$placesearch_url = getURL( "placesearch", 1 );
$places_oneletter_url = getURL( "places-oneletter", 1 );

header("Content-type:text/html; charset=" . $session_charset);

if($tree != "todas")
	$gedcom = "AND TP.gedcom = '$tree'";
else
	$gedcom = "";

$nameStr = explode(" ", trim($tcccriterio));
$wordcount = sizeof($nameStr);

$tcc_precision = trim($precisao);

begin();

$tcc_query2 = "DROP TABLE IF EXISTS t_qgrams;";
$tcc_query3 = "CREATE TEMPORARY TABLE t_qgrams (wordnum int, I int, gram varchar(3));";

tng_query($tcc_query2) or die ($text['cannotexecutequery'] . ": $tcc_query2 <br> ". tng_error());
tng_query($tcc_query3) or die ($text['cannotexecutequery'] . ": $tcc_query3 <br> ". tng_error());

$tcc_query2 = "DROP TABLE IF EXISTS t_query;";
$tcc_query3 = "CREATE TEMPORARY TABLE t_query (wordnum int, nome varchar(100));";

tng_query($tcc_query2) or die ($text['cannotexecutequery'] . ": $tcc_query2 <br> ". tng_error());
tng_query($tcc_query3) or die ($text['cannotexecutequery'] . ": $tcc_query3 <br> ". tng_error());

for ($i = 0; $i < $wordcount; $i++) {
	$nameWord = $nameStr[$i];
	$wordnum = $i + 1;
	$tcc_query2 = "INSERT INTO t_qgrams (wordnum, I, gram)
		SELECT $wordnum, n.I, SUBSTRING( CONCAT(  '##', '$nameWord',  '$$' ) , n.I, 3 ) 
		FROM qgrams_n n
		WHERE n.I <= CHAR_LENGTH('$nameWord') + 2;";
	$tcc_query3 = "INSERT INTO t_query (wordnum, nome)
		VALUES ($wordnum, '$nameWord');";
	tng_query($tcc_query2) or die ($text['cannotexecutequery'] . ": $tcc_query2 <br> ". tng_error());			
	tng_query($tcc_query3) or die ($text['cannotexecutequery'] . ": $tcc_query3 <br> ". tng_error());			
}

$tcc_query2 = "SELECT distinct 
	TP.place as myplace, 
	TP.place as wholeplace, 
	TP.gedcom, 
	gramscountsum
FROM 
 (SELECT LocalID, SUM(gramscount) AS gramscountsum FROM 
	(SELECT QG.NameID, TMPG.wordnum,
		QN.Nome AS nomebd,
		QN.TableID,
		QN.LocalID,
	    TQU.nome AS nomecons,
		COUNT(*) as gramscount
	 FROM       qgrams_names QN
	 INNER JOIN qgrams_grams QG ON QG.NameID = QN.NameID
	 INNER JOIN t_qgrams TMPG ON TMPG.gram = QG.gram
	 INNER JOIN t_query TQU ON TQU.wordnum = TMPG.wordnum
	  WHERE     QG.I <= TMPG.I + $tcc_precision
			AND QG.I >= TMPG.I - $tcc_precision
			AND CHAR_LENGTH(QN.Nome) <= CHAR_LENGTH(TQU.nome) + $tcc_precision
			AND CHAR_LENGTH(QN.Nome) >= CHAR_LENGTH(TQU.nome) - $tcc_precision
			AND QN.TableID = 2
		GROUP BY QG.NameID, QN.Nome, TMPG.wordnum, TQU.nome
		HAVING COUNT(*) >= CHAR_LENGTH(QN.Nome) - 1 - ($tcc_precision-1) * 3 
		   AND COUNT(*) >= CHAR_LENGTH(TQU.nome) - 1 - ($tcc_precision-1) * 3
order by gramscount desc
	) AS wordtable
GROUP BY LocalID
HAVING COUNT(*) >= $wordcount
) AS SPP
INNER JOIN $places_table TP ON SPP.LocalID = TP.ID
							   $gedcom
ORDER BY gramscountsum DESC;
";

$result = tng_query($tcc_query2) or die ($text['cannotexecutequery'] . ": $tcc_query2 <br> ". tng_error());
		

if(!$result)
{
	rollback(); // transaction rolls back
}
else
{
	commit();
}
if( $result ) {
	$snnum = 1;
	$num_in_col = 20;
	$numrows = tng_num_rows($result);
	$numcols = floor($numrows / $num_in_col);
	if( $numcols > 3 ) {
		$numcols = 3;
		$num_in_col = ceil($numrows / 3 );
	}
	
	$num_in_col_ctr = 0;
	while( $place = tng_fetch_assoc( $result ) ) {
		$place2 = urlencode( $place['myplace'] );
		if( $place2 ) {
			$commaOnEnd = false;
			$poffset = $stretch ? "" : "offset=$offset&amp;";
			if(substr($place['wholeplace'],0,1) == ',' && trim(substr($place['wholeplace'],1)) == $place['myplace']) {
				$place3 = addslashes($place['wholeplace']);
				$commaOnEnd = true;
				$place2 = urlencode($place['wholeplace']);
				$placetitle = $place['wholeplace'];
			}
			else {
				$place3 = addslashes($place['myplace']);
				$placetitle = $place['myplace'];
			}

			$query = "SELECT count(place) as placecount FROM $places_table WHERE place = \"$place3\" $wherestr2";
			$result2 = tng_query($query) or die ($text['cannotexecutequery'] . ": $query");
			$countrow = tng_fetch_assoc($result2);
			$specificcount = $countrow['placecount'];
			tng_free_result($result2);

			$searchlink = $specificcount ? " <a href=\"$placesearch_url" . "{$treestr}psearch=$place2\" title=\"{$text['findplaces']}\"><img src=\"{$cms['tngpath']}img/tng_search_small.gif\" border=\"0\" alt=\"{$text['findplaces']}\" width=\"9\" height=\"9\" /></a>" : "";
			if( $place['placecount'] > 1 || ($place['myplace'] != $place['wholeplace'] && !$commaOnEnd) ) {
//				$name = "<a href=\"$places_oneletter_url" . $poffset;
				$name = "<a href=\"$placesearch_url" . $poffset;
				if($tree && !$tngconfig['places1tree']) $name .= "tree={$place['gedcom']}&amp;";
				$name .= "psearch=$place2\">";

				$name .= $place['myplace'];
				//if($session_charset == "UTF-8")
					//$name .= htmlentities(utf8_decode($place['myplace']),ENT_QUOTES); // this line handles UTF8 issues - R?al Charlebois
                    //$name .= $place['myplace']; // Roger removed R?al's coding here - it works with curly single quote now
				//else
					//$name .= htmlentities($place['myplace'],ENT_QUOTES); // this line is not compatible with UTF8 (htmlentities)
				$name .= "</a>";

				echo "$snnum. $name ({$place['placecount']})$searchlink<br/>\n";
			}
			else
				echo "$snnum. $placetitle$searchlink<br/>\n";
			$snnum++;
			$num_in_col_ctr++;
			if( $num_in_col_ctr == $num_in_col ) {
				echo "</span></td>\n<td width=\"20\">&nbsp;&nbsp;</td>\n<td valign=\"top\"><span class=\"normal\">";
				$num_in_col_ctr = 0;
			}
		}
	}
	tng_free_result($result);
}


function begin()
{
tng_query("BEGIN");
}

function commit()
{
tng_query("COMMIT");
}

function rollback()
{
tng_query("ROLLBACK");
}
?>